unit GetFolder;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ShlObj;

type                                                       //Lschen?
  TWhatFolder = ({RecycleBin, ControlPanel,} WindowsDesktop, FSDesktop, //MyComputer,
                 Fonts, NetworkNeighborhood, FSCommonDocuments, //Printers,
                 FSMPrograms, FSMUsingDoc, FSSendTo, FSStartMenu, FSStartUp, FSTemplates);
  TGetFolder = class(TComponent)
  private
   FWhatFolder: TWhatFolder;
   WFolder: Integer;
   p : pitemidlist;
   Folder : pchar;
   procedure SetWhatFolder(Value: TWhatFolder);
  protected
    { Protected declarations }
  public
    function GetFolder: PChar;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property WhatFolder: TWhatFolder read FWhatFolder
                                     write SetWhatFolder;
  end;

procedure Register;

var
 MainForm: TForm;

implementation

constructor TGetFolder.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
 MainForm := TForm(AOwner);
end;

destructor TGetFolder.Destroy;
begin
 inherited Destroy;
end; 

procedure TGetFolder.SetWhatFolder(Value: TWhatFolder);
begin
FWhatFolder := Value;
end;

function TGetFolder.GetFolder: PChar;
begin
//if FWhatFolder = RecycleBin then
 //WFolder :=  CSIDL_BITBUCKET;
//if FWhatFolder = ControlPanel then
 //WFolder := CSIDL_CONTROLS;
if FWhatFolder = WindowsDesktop then
 WFolder := CSIDL_DESKTOP;
if FWhatFolder = FSDesktop then
 WFolder := CSIDL_DESKTOPDIRECTORY;
//if FWhatFolder = MyComputer then
 //WFolder := CSIDL_DRIVES;
if  FWhatFolder = NetworkNeighborhood then
 WFolder := CSIDL_NETHOOD;
if FWhatFolder = Fonts then
 WFolder :=  CSIDL_FONTS;
if FWhatFolder = FSCommonDocuments then
 WFolder := CSIDL_PERSONAL;
//if FWhatFolder = Printers then
 //WFolder := CSIDL_PRINTERS;
if FWhatFolder = FSMPrograms then
   WFolder := CSIDL_PROGRAMS;
if FWhatFolder = FSMUsingDoc then
 WFolder := CSIDL_RECENT;
if FWhatFolder = FSSendTo then
 WFolder := CSIDL_SENDTO;
if FWhatFolder = FSStartMenu then
 WFolder := CSIDL_STARTMENU;
if FWhatFolder = FSStartUp then
 WFolder := CSIDL_STARTUP;
if FWhatFolder = FSTemplates then
 WFolder := CSIDL_TEMPLATES;
      
   SHGetSpecialFolderLocation (MainForm.Handle, WFolder, p);
   new (Folder);
   getmem (Folder, 255);
   SHGetPathFromIDList (p, Folder);
   Result := Folder;
end;

procedure Register;
begin
  RegisterComponents('Win32', [TGetFolder]);
end;

end.
 